 		title	DOS subroutines

	
data	segment	public
handle	dw	?
bytbuf	db	?
fnmsg	db	'Enter filename: ',0
em1	db	'Disk open error: ',0
em2	db	'Disk close error: ',0
em3	db	'Disk read error: ',0
em4	db	'Disk write error: ',0
em5	db	'Disk file error: ',0
ercode	db	'Invalid fnc no.',0
	db	'File not found ',0
	db	'Path not found ',0
	db	'No free handles',0
	db	'Access denied  ',0
	db	'Invalid handle ',0
	db	'Memory error   ',0
	db	'Out of memory  ',0
	db	'Invaled address',0
	db	'Bad environment',0
	db	'Invalid format ',0
	db	'Bad access code',0
	db	'Invalid data   ',0
	db	'Bad drive spec.',0
	db	'Current dir.   ',0
	db	'Not same device',0
	db	'No files found ',0
data	ends

	extrn	mess:near,chrout:near,beep:near
	extrn	setcur:near,mess2:near
	extrn	curoff:near,digit:near
	extrn	convert:near,number:near
	extrn	dnegate:near,sharps:near
	extrn	clrscn:near,tab:near,query:near
	extrn	kbuf:byte,bufend:byte
	extrn	negflg:byte,dnum:dword
	extrn	span:word

	public	open,close,read,write,rewind
	public	gtbyte,gtdgt,gtnum,gtrnum
	public	sndbyte,sndnum,openfn,movptr
	public	getlen,sndcrlf,create,handle

	page
code	segment	public
	assume	cs:code,ds:data

;	open or create file
;	input:  dx -> asciiz string
;	output: bx = handle
open	proc	near
	push	cx
	mov	al,2		;read & write
	mov	ah,3dh
	int	21h		;open file
	jnc	op2
	cmp	ax,2		;if file
	jne	op1		; not found
	mov	ah,3ch		;create
	mov	cx,0		; normal attr
	int	21h		; file
	jnc	op2
op1:	call	open_err	;error mess
	stc	
	jmp	op3
op2:	mov	bx,ax		;bx=handle
op3:	pop	cx
	ret
open	endp

;	close file
;	input:	bx = handle
close	proc	near
	mov	ah,3eh
	int	21h		;close file
	jnc	cl1		;if error
	call	close_err	; print it
	stc
cl1:	ret
close	endp

	page
;	create file
;	(set length to zero to write over)
;	input:  dx -> asciiz string
;	output: bx = handle
create	proc	near
	push	cx
	mov	ah,3ch		;create
	mov	cx,0		; normal attr
	int	21h		; file
	jnc	ct2
ct1:	call	open_err	;error mess
	stc
	jmp	ct3
ct2:	mov	bx,ax		;bx=handle
ct3:	pop	cx
	ret
create	endp

;	read file
;	input:	bx = handle  
;		cx = # of bytes to read
;		dx -> buffer address
;	output:	ax = # of bytes read
;		ax = 0 if EOF
read	proc	near
	mov	ah,3fh
	int	21h		;read file
	jnc	rd1		;if error
	call	read_err	; print it
	stc
rd1:	ret
read	endp


;	write file
;	input:	bx = handle  
;		cx = # of bytes to write
;		dx -> buffer address
write	proc	near
	mov	ah,40h
	int	21h		;write file
	jnc	wt1		;if error
	call	write_err	; print it
	stc
wt1:	ret
write	endp

	page
;	rewind file
;	input:	bx = handle  
rewind	proc	near
	push	cx
	push	dx
	mov	cx,0
	mov	dx,0		;offset=0
	mov	al,0		;mov ptr from
	mov	ah,42h		; start of file
	int	21h
	jnc	rw1		;if error
	call	ptr_err		; print it
	stc
rw1:	pop	dx
	pop	cx
	ret
rewind	endp

;	get length of file
;	input:	bx = handle
;	output:	dx:ax = length of file  
getlen	proc	near
	push	cx
	mov	cx,0
	mov	dx,0		;offset=0
	mov	al,2		;mov ptr from
	mov	ah,42h		; end of file
	int	21h
	jnc	gl1		;if error
	call	ptr_err		; print it
	stc
gl1:	pop	cx
	ret
getlen	endp

	page
;	get next byte
;	input:	bx = handle  
;	output: al = byte
;		carry = 1 if EOF
gtbyte	proc	near
	push	cx
	push	dx
	mov	cx,1		;read 1 byte
	mov	dx,offset bytbuf
	call	read
	cmp	ax,0		;if EOF
	jne	gb1
	stc			; set carry
	jmp	gb2		;else
gb1:	mov	al,bytbuf	;al=byte
	clc			;clear carry
gb2:	pop	dx
	pop	cx
	ret
gtbyte	endp

;	check for quote string
quote	proc	near
	cmp	al,'"'		;if "
	je	qt1
	ret
qt1:	call	gtbyte		;get byte
	cmp	al,'"'		;until
	jne	qt1		; another "
	call	gtbyte		;get next byte
	ret
quote	endp

	page
;	get next digit (in current base)
;	input:	bx = handle  
;	output: al = ascii digit value
;		carry = 1 if EOF
gtdgt	proc	near
gt1:	call	gtbyte		;get next byte
	jc	gt2		;until EOF
	call	quote		;check for "
	push	ax		;save ascii val
	call	digit		;or valid digit
	pop	ax		;get ascii val
	jc	gt1
gt2:	ret
gtdgt	endp

;	get next digit or a - sign
;	input:	bx = handle  
;	output: al = ascii digit value
;		carry = 1 if EOF
gtdgtm	proc	near
gtm1:	call	gtbyte		;get next byte
	jc	gtm2		;until EOF
	call	quote		;check for "
	cmp	al,'-'		;if - sign
	je	gtm2		; quit
	push	ax		;save ascii val
	call	digit		;or valid digit
	pop	ax		;get ascii val
	jc	gtm1
gtm2:	ret
gtdgtm	endp

	page
;	get next number (in current base)
;	input:	bx = handle  
;	output: dx:ax = double number
;		carry = 1 if EOF
gtnum	proc	near
	push	si
	push	di
	push	ds
	pop	es		;es=ds
	cld
	mov	word ptr dnum,0	;clear dnum
	mov	word ptr dnum+2,0
	mov	di,offset kbuf
	call	gtdgt		;get next digit
	jc	gn3		;while not EOF
	stosb			; save digit
gn1:	call	gtbyte		;get next byte
	jc	gn3
	call	quote		;check for "
	push	ax		;save ascii val
	call	digit		;while a digit
	pop	ax		;get ascii val
	stosb			; save it	
	jc	gn2
	jmp	gn1
gn2:	mov	si,offset kbuf
	mov	di,offset dnum
	call	convert		;convert to
	mov	ax,word ptr dnum ; double
	mov	dx,word ptr dnum+2 ; number
gn3:	pop	di
	pop	si
	ret
gtnum	endp

	page
;	get next real number (in current base)
;	input:	bx = handle  
;	output: dx:ax = double number
;		cx = # to right of dp
;		carry = 1 if EOF or no number
gtrnum	proc	near
	push	si
	push	di
	push	ds
	pop	es		;es=ds
	cld
	mov	di,offset kbuf
	call	gtdgtm		;get digit or -
	jc	grn3		;while not EOF
	stosb			; save digit
grn1:	call	gtbyte		;get next byte
	jc	grn3
	call	quote		;check for "
	cmp	al,'.'		;save .
	je	grn4		
	push	ax		;save ascii val
	call	digit		;save a digit
	pop	ax		;get ascii val
	jc	grn2
grn4:	stosb			; save it
	jmp	grn1
grn2:	stosb			;invalid digit
	mov	si,offset kbuf
	call	number		;convert 
grn3:	pop	di
	pop	si
	ret
gtrnum	endp

	page
;	send byte
;	input:	bx = handle
;		al = byte
sndbyte	proc	near
	push	cx
	push	dx
	mov	bytbuf,al	;bytbuf=byte
	mov	dx,offset bytbuf
	mov	cx,1		;1 byte
	call	write		;send it
	pop	dx
	pop	cx
	ret
sndbyte	endp

;	send crlf
sndcrlf	proc	near
	mov	al,13		;send cr
	call	sndbyte
	mov	al,10		;send lf
	call	sndbyte
	ret
sndcrlf	endp

	page
;	send number
;	input:	bx = handle
;		dx:ax = double number
sndnum	proc	near
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	mov	negflg,0	;clear negflg
	or	dx,dx		;if negative
	jns	sn1
	not	negflg		;set negflg
	call	dnegate		;negate dnum
sn1:	mov	di,offset bufend ;di -> asc buf
	mov	si,offset dnum	;si -> bin buf
	mov	[si],ax
	mov	2[si],dx
	call	sharps		;conv digits
	cmp	negflg,0	;if negative
	je	sn2
	mov	al,'-'		;store -
	mov	[di],al		; in buffer
	dec	di
sn2:	mov	dx,di		;dx -> string
	inc	dx
	mov	cx,offset bufend
	sub	cx,di		;cx=#digits
	call	write		;send string
	pop	di
	pop	si
	pop	dx
	pop 	cx
	pop	bx
	pop	ax
	ret
sndnum	endp

	page
;	move pointer
;	input:	bx = handle
;		cx:dx = offset value
;		al = 0 - start of file + offset
;		     1 - inc ptr by offset
;	output:	dx:ax = new value of ptr
movptr 	proc	near
	mov	ah,42h		;move ptr
	int	21h
	jnc	mpt1
	call	ptr_err
	stc
mpt1:	ret
movptr	endp

;	enter filename and open
;	input:	none
;	output:	handle is in 'handle'
;	carry = 1 if not opened
openfn	proc	near
	push	bx
	push	dx
	push	si
	mov	si,offset fnmsg	
	call	mess2		;display mess
	call	query		;enter filename
	cmp	span,0		;if no chars
	jne	of0		; set carry
	stc			; and quit
	jmp	of1
of0:	mov	dx,offset kbuf
	call	open		;open it
	jc	of1		;if error,quit
	mov	handle,bx	;store handle
of1:	pop	si
	pop	dx
	pop	bx
	ret
openfn	endp

	page
;	disk errors
open_err proc	near
	push	bx
	push	dx
	push	si
	call	beep
	mov	bl,7
	mov	dx,1801h	;bottom line
	mov	si,offset em1	;print
	call	mess		; error message
	mov	bx,ax		;bx=err code
	call	errmsg
	pop	si
	pop	dx
	pop	bx
	ret
open_err endp

close_err proc	near
	push	bx
	push	dx
	push	si
	call	beep
	mov	bl,7
	mov	dx,1801h	;bottom line
	mov	si,offset em2	;print
	call	mess		; error message
	mov	bx,ax		;bx=err code
	call	errmsg
	pop	si
	pop	dx
	pop	bx
	ret
close_err endp

read_err proc	near
	push	bx
	push	dx
	push	si
	call	beep
	mov	bl,7
	mov	dx,1801h	;bottom line
	mov	si,offset em3	;print
	call	mess		; error message
	mov	bx,ax		;bx=err code
	call	errmsg
	pop	si
	pop	dx
	pop	bx
	ret
read_err endp

	page
write_err proc	near
	push	bx
	push	dx
	push	si
	call	beep
	mov	bl,7
	mov	dx,1801h	;bottom line
	mov	si,offset em4	;print
	call	mess		; error message
	mov	bx,ax		;bx=err code
	call	errmsg
	pop	si
	pop	dx
	pop	bx
	ret
write_err endp

ptr_err proc	near
	push	bx
	push	dx
	push	si
	call	beep
	mov	bl,7
	mov	dx,1801h	;bottom line
	mov	si,offset em5	;print
	call	mess		; error message
	mov	bx,ax		;bx=err code
	call	errmsg
	pop	si
	pop	dx
	pop	bx
	ret
ptr_err endp
	
;	error code message
errmsg	proc	near
	mov	si,offset ercode
	mov	cl,4		;si->ercode
	dec	bx
	shl	bx,cl		; +16*code
	add	si,bx
	mov	bl,07h
	call	mess
	ret
errmsg	endp

code	ends
	end	

