 	title	Colon definitions
 
stack	segment	para	stack
	db	256 dup(?)
stack	ends

IMMED	EQU	080H		;immediate precedence bit

data	segment	public
to_in	dw	?
here	db	16 dup(?)
msg1	db	' <-- What??',0
msgok	db	' ok ',0
bptop	dw	?
state	db	?
dp	dw	?		;dictionary ptr
last	dw	?		;ptr to last name
data	ends

bpush	macro	val
	xchg	bp,sp		;push val
	push	val		;on bp stack
	xchg	bp,sp
	endm

bpop	macro	val
	xchg	bp,sp		;pop val
	pop	val		;from bp stack
	xchg	bp,sp
	endm

_link	= 0

$head	macro	lex,name,sub
	dw	sub
	dw	_link
	_link = $		;current addr
	db	lex,name
	endm

	extrn	clrscn:near,dokey:near
	extrn	query:near,number:near
	extrn	pax:near,crlf:near
	extrn	mess2:near,chrout1:near
	extrn	kbuf:byte,beep:near
	extrn	span:word,ddiv:near
	extrn	pdxax:near,updxax:near
	extrn	decflg:byte

code	segment	public
	assume	cs:code,ds:data

	page
main	proc	far
	mov	ax,data
	mov	ds,ax		;set ds
	mov	es,ax		;es=ds
	mov	bp,sp
	sub	bp,128		;set data stack
	mov	bptop,bp	;set bptop
	mov	state,0		;interpreting
	mov	ax,offset dict
	mov	dp,ax		;dp->dictionary
	mov	ax,cs:current
	mov	last,ax		;last->current
	cld			;dir increase
	call	clrscn		;clear screen
mn1:	mov	to_in,0		;t0_in=0
	call	prompt		;ok prompt
	call	query		;get input
mn2:	call	getword		;get next word
	cmp	here,0		;if no word
	je	mn1		; get new input
	call	doword		;eval word
	jmp	mn2
main	endp
	
;	parse string for blanks between words
;	input:	si -> string
;		cx -> length of string
;	output:	si -> 1st char of parsed word
;		di -> 1st blank after word
parse	proc	near
	mov	di,si		;di->string
	push	ds
	pop	es		;es=ds
	cld			;di increases
	mov	al,20h		;look for blank
	jcxz	pr2		;skip no string
	repe scasb		;skip leading
	je	pr1		; blanks
	inc	cx		;back up to 1st
	dec	di		; non blank
pr1:	mov	si,di		;si->next word
	jcxz	pr2		;skip no string
	repne scasb		;find 1st blank
	jne	pr2		; after word
	inc	cx		;back up to 1st
	dec	di		; blank
pr2:	ret
parse	endp

;	parse next word & move to here
getword	proc	near
	mov	si,offset kbuf
	add	si,to_in	;si->to_in
	mov	cx,span		;cx = # of
	sub	cx,to_in	;chars left
	jcxz	wd1		;if 0 do again
	call	parse		;get next word
	mov	cx,di		;cx=# char
	sub	cx,si		; in word
	mov	ax,di
	sub	ax,offset kbuf
	mov	to_in,ax	;set to_in
wd1:	mov	di,offset here	;move word
	mov	[di],cl		; as $string
	inc	di		; to here
	jcxz	wd2
	rep movsb
wd2:	mov	al,0		; make asciiz
	stosb
	ret
getword	endp

$head	2,'D+',dplus
$head	2,'D-',dminus
$head	6,'MU/MOD',mumod
$head	3,'UM*',dtimes
$head	2,'D.',ddott
$head	3,'UD.',uddott
$head	1,'+',plus
$head	1,'-',minus
$head	1,'*',times
$head	1,'/',slash
$head	1,'.',dott
$head	2,'.S',dots
$head	1,':',colon
$head	IMMED+1,';',semis
current	dw	_link

;	find word in dictionary and execute it
doword	proc	near
	push	cs
	pop	es		;es=cs
	mov	di,last		;di->last name
	mov	al,here		;al=count
dwd1:	mov	si,offset here	;si->$string
	inc	si		;si->1st char
	mov	cl,cs:[di]
	and	cl,1fh		;cl=head cnt
	cmp	al,cl		;if cnts don't
	je	dwd2		; match
	mov	di,cs:-2[di] 	;follow link
	or	di,di		;if link=0
	jne	dwd1		; not found
	call	cknum		;chk number
	ret
dwd2:	mov	bx,di		;bx->name$
	mov	cl,al		;cx=count
	mov	ch,0
	inc	di		;di->1st char
	repe cmpsb		;compare $s
	je	found		;if not found
	mov	di,cs:-2[bx] 	;follow link
	or	di,di		;if link=0
	jne	dwd1		; not found
	call	cknum		;chk number
	ret
found:	mov	al,cs:[bx]	;chk immed bit
	or	al,al		;if immed
	jns	dwd4		; execute	
	cmp	state,0ffh	; if compiling
	je	dwd5
	ret
dwd4:	cmp	state,0		;if interpret
	jne	dwd3
dwd5:	call	cs:-4[bx]	; call sub
	ret			;else
dwd3:	mov	ax,cs:-4[bx]
	call	compile		; compile sub
	ret
doword	endp

dplus	proc	near
	bpop	dx
	bpop	ax		;get dx:ax
	bpop	cx
	bpop	bx		;get cx:bx
	add	ax,bx
	adc	dx,cx		;add
	bpush	ax
	bpush	dx		;push dx:ax
	ret
dplus	endp

dminus	proc	near
	bpop	cx
	bpop	bx		;get cx:bx
	bpop	dx
	bpop	ax		;get dx:ax
	sub	ax,bx
	sbb	dx,cx		;subtract
	bpush	ax
	bpush	dx		;push dx:ax
	ret
dminus	endp

;	MU/MOD  ( ud un -- rem dquot )
mumod	proc	near
	bpop	bx		;un
	bpop	dx		;udH
	bpop	ax		;udL
	call	ddiv		;ud/un
	bpush	bx		;push rem
	bpush	ax
	bpush	dx		;push dquot
	ret
mumod	endp

;	UM*  ( un1 un2 -- ud )  ud = un1 * un2
dtimes	proc	near
	bpop	ax
	bpop	bx
	mul	bx		;unsigned prod
	bpush	ax		;is in dx:ax
	bpush	dx
	ret
dtimes	endp

;	print signed double number
ddott	proc	near
	mov	al,20h
	call	chrout1
	bpop	dx
	bpop	ax		;get dvalue
	call	pdxax		;print it
	ret
ddott	endp

;	print unsigned double number
uddott	proc	near
	mov	al,20h
	call	chrout1
	bpop	dx
	bpop	ax		;get dvalue
	call	updxax		;print it
	ret
uddott	endp

;	add top 2 elements on data stack
plus	proc	near
	bpop	ax
	bpop	bx
	add	ax,bx
	bpush	ax
	ret
plus	endp
	
;	subtract top 2 elements on data stack
minus	proc	near
	bpop	bx
	bpop	ax
	sub	ax,bx
	bpush	ax
	ret
minus	endp

;	multiply top 2 elements on data stack
times	proc	near
	bpop	ax
	bpop	bx
	mul	bx		;signed prod
	bpush	ax		;is in ax!
	ret
times	endp

;	divide 2nd element on data stack
;	by the top element on data stack
slash	proc	near
	bpop	bx		;bx=denom
	bpop	ax
	or	ax,ax		;if negative
	jns	sl1
	mov	dx,0ffffh	;sign extend
	jmp	sl2		;else
sl1:	mov	dx,0		;0:ax=numer
sl2:	idiv	bx		;signed divide
	bpush	ax
	ret
slash	endp

;	display top element on stack
dott	proc	near
	mov	al,20h
	call	chrout1
	bpop	ax		;get value
	call	pax		;print it
	ret
dott	endp

;	check word for number
cknum	proc	near
	push	si
	push	di
	mov	si,offset here	;si->$string
	mov	al,[si]
	mov	ah,0		;ax = count
	inc	si
	mov	bx,si
	add	bx,ax		;bx->00(end)
	call	number		; get number
	cmp	si,bx		;bx->00
	jne	ck1		;if valid
	cmp	state,0		; & interp
	jne	ck0
	bpush	ax		; push ax
	cmp	decflg,0	; if .
	je	ck2
	bpush	dx		; push dx
	jmp	ck2		;else
ck0:	call	litnum		; literal num
	jmp	ck2
ck1:	call	errmsg		;error message
ck2:	pop	di
	pop	si
	ret
cknum	endp

;	print error message
errmsg	proc	near
	call	crlf
	mov	si,offset here
	inc	si
	call	mess2		;print word
	mov	si,offset msg1
	call	mess2		; <-- What??
	ret
errmsg	endp

;	print ok prompt
prompt	proc	near
	mov	si,offset msgok
	call	mess2		; ok
	call	crlf
	ret
prompt	endp


;	display data stack
dots	proc	near
	push	ax
	push	cx
	push	si
	mov	cx,bptop	;#items =
	sub	cx,bp		;(bptop-bp)
	mov	si,cx
	shr	cx,1		; /2
	sub	si,2		;si=index
	jcxz	dts2
dts1:	mov	ax,[bp][si]	;next val
	push	ax
	mov	al,20h		;print
	call	chrout1		; blank
	pop	ax
	call	pax		;print it
	sub	si,2		;bump index
	loop	dts1		;do all items
dts2:	pop	si
	pop	cx
	pop	ax
	ret
dots	endp

;	colon definition
colon	proc	near
	mov	state,0ffh	;set state
	call	getword		;get name
	call	makehdr		;make header
	ret
colon	endp

;	compile address
;	input:	ax = sub address
compile	proc	near
	push 	cs
	pop	es		;es = cs
	mov	di,dp		;di=dp
	mov	byte ptr es:[di],0E8h
	inc	di		;CALL opcode
	sub	ax,di		;calc displ
	sub	ax,2
	stosw			;store displ
	mov	dp,di		;update di
	ret
compile	endp

;	make header of word at here
makehdr	proc	near
	push	cs
	pop	es		;es = cs
	mov	di,dp		;di=dp
	mov	bx,di		;bx=dp
	add	di,2		;store link
	mov	ax,last
	stosw
	mov	last,di		;update last
	mov	si,offset here
	mov	cl,[si]
	inc	cl		;move counted
	mov	ch,0		;string from
	rep movsb		;here
	mov	es:[bx],di	;fill ^sub
	mov	dp,di		;update dp
	ret
makehdr	endp

;	semi-colon
semis	proc	near
	push	cs
	pop	es		;es=cs
	mov	state,0		;clear state
	mov	di,dp
	mov	al,0C3h		;store RET
	stosb
	mov	dp,di		;update dp
	ret
semis	endp

;	store literal number
litnum	proc	near
	push	dx		;save number
	push	ax
	cmp	decflg,0	;if single
	jne	ln1
	mov	ax,offset lit	;compile lit
	call	compile
	pop	ax		;and ax
	stosw
	pop	dx
	jmp	ln2		;else
ln1:	mov	ax,offset dlit	;compile dlit
	call	compile
	pop	ax
	stosw			;and dx:ax
	pop	dx
	stosw
ln2:	mov	dp,di		;update di
	ret
litnum	endp

;	runtime routine for single literals
lit	proc	near
	pop	di		;di->number
	mov	ax,cs:[di]	;push number
	bpush	ax		;on data stack
	add	di,2		;jump over num
	push	di
	ret
lit	endp

;	runtime routine for double literals
dlit	proc	near
	pop	di		;di->number
	mov	ax,cs:[di]	;push number
	bpush	ax		;on data stack
	add	di,2		;jump over num
	mov	ax,cs:[di]
	bpush	ax
	add	di,2
	push	di
	ret
dlit	endp

;	reserve dictionary space	
dict	db	8000h	dup (?)

code	ends
	end	main

			

