	title  Screen display subroutines

;	useful key ascii codes
_esc	equ	27
_enter	equ	13
_bksp	equ	8
	
data	segment	public
kbuf	db	80 dup(?)
bufend	db	?
vidseg	dw	0b800h		;video RAM segment
span	dw	?
sisave	dw	?
svseg	dw	0
data	ends

	public	vidseg,stvseg
	public	savescr,restscr
	public	svinit,relssb,resize
	public	delay,tone,beep,quit
	public  chrout,mess,chrout1,getatt
	public  setcur,rdcurs,inccur,deccur
	public  clrscn,home,tab,chgatt
	public  invatt,blank,clrwin,curoff
	public  chrprt,hexasc,pbyte
	public  togatt,crlf,mess2,fmess
	public	getkey,dokey,invline
	public	query,kbuf,bufend,span
	public	enterq,sisave

code	segment public
	assume cs:code,ds:data

;	set video RAM segment address
stvseg	proc	near
	push	ax
	mov	ah,15
	int	10h		;get video state
	cmp	al,7		;if monochrome
	jne	svg1
	mov	vidseg,0b000h	; vidseg=b000
	jmp	svg2		;else
svg1:	mov	vidseg,0b800h	; vidseg=b800
svg2:	pop	ax
	ret
stvseg	endp

;	display char with current attribute
chrout1	proc	near
	push	ax
	push	bx
	push	ax		;save char
	mov	bh,0		;page 0
	mov	ah,8
	int	10h		;read attribute
	mov	bl,ah
	pop	ax		;get char
	call	chrout		;& display
	pop	bx
	pop	ax
	ret
chrout1	endp

	page
;	character output
chrout	proc near
	push	ax
	push	bx		;save regs
	push	cx
	push	dx
	push	ax
	mov	bh,0
	mov	ah,3
	int	10h		;read cursor
	mov	cx,1
	pop	ax		;get char
	cmp	al,0dh		;check for CR
	je	chr1
	cmp	al,20h		;ignore ctrl
	jb	chr3		; characters
	mov	ah,9
	int	10h		;write char/att
	inc	dl		;inc cursor
	cmp	dl,80		;if end of line
	jb	chr2
chr1:	mov	dl,0		;do CR
	inc	dh		; LF
	cmp	dh,25		;if end of
	jb	chr2		; screen
	mov	cx,0		;scroll
	mov	dx,184fh	; entire
	mov	bh,07h		; screen
	mov	ax,0601h	; up
	int	10h		; 1 line
	mov	dx,1800h	;CR
	mov	bh,0		;reset page no.
chr2:	mov	ah,2
	int	10h		;set new cursor
chr3:	pop	dx		;restore regs
	pop	cx
	pop	bx
	pop	ax
	ret
chrout	endp

	page
;	message display
;	si -> message in data segment
;	dh = row, dl = col
;	bl = attribute of message
mess	proc	near
	push	ax
	push	bx
	push	cx
	push	si
	mov	bh,0		;page 0
	mov	ah,2		;set cursor
	int	10h		; at dh,dl
	mov	cx,1		;1 character
	cld			;si increases
ms1:	lodsb			;[si]-->al
	cmp	al,0		;message done?
	je	ms2		;if so, return
	call	chrout		;display char
	jmp	ms1		;and continue
ms2:	pop	si
	pop	cx
	pop	bx
	pop	ax
	ret
mess	endp

;	message display with current attribute
;	at current cursor positon
;	si -> message in data segment
mess2	proc	near
	push	ax
	push	bx
	push	dx
	call	rdcurs		;read cursor
	mov	bh,0		;page 0
	mov	ah,8
	int	10h		;read attribute
	mov	bl,ah
	call	mess		;display mess
	pop	dx
	pop	bx
	pop	ax
	ret
mess2	endp

;	fast message routine
fmess	proc	near
	push	ax
	push	di
	call	setdi		;set di->vidRAM offset
	mov	ah,bl		;ah=attribute
	mov	es,vidseg	;es->video RAM
	cld
fms1:	lodsb
	cmp	al,0
	je	fms2
	stosw
	jmp	fms1
fms2:	pop	di
	pop	ax
	ret
fmess	endp

;	set di to video RAM offset address
;	di = row * 160 + col
setdi	proc	near
	push	cx
	mov	ah,0
	mov	al,dh		;ax=row
	mov	cl,5
	shl	ax,cl		;ax=32*row
	mov	di,ax		;di=32*row
	shl	ax,1
	shl	ax,1		;ax=128*row
	add	di,ax		;di=160*row
	mov	ah,0
	mov	al,dl		;ax=col
	shl	ax,1		;ax=2*col
	add	di,ax		;di=video offset
	pop	cx
	ret
setdi	endp

	page
;	set cursor at dx=row:col 
setcur	proc 	near
	push	ax
	push	bx
	mov	bh,0		;page 0
	mov	ah,2
	int	10h		;set cursor
	pop	bx
	pop	ax
	ret
setcur	endp

;	read cursor
;	output:  dh=row  dl=col
rdcurs	proc	near
	push	ax
	push	bx
	push	cx
	mov	bh,0		;page 0
	mov	ah,3
	int	10h		;read cursor
	pop	cx
	pop	bx
	pop	ax
	ret
rdcurs	endp

;	inc cursor
inccur	proc	near
	push	dx
	call	rdcurs		;read cursor
	inc	dl		;inc dl
	call	setcur		;set cursor
	pop	dx
	ret
inccur	endp

;	dec cursor
deccur	proc	near
	push	dx
	call	rdcurs		;read cursor
	dec	dl		;inc dl
	call	setcur		;set cursor
	pop	dx
	ret
deccur	endp

	page 
;	clear screen
clrscn	proc	near
	push	ax
	mov	ah,15		;read vid mode
	int	10h
	mov	ah,0		;and set again
	int	10h
	pop	ax
	ret
clrscn	endp

;	home cursor
home	proc	near
	push	dx
	mov	dx,0		;row=0 col=0
	call	setcur
	pop	dx
	ret
home	endp

;	carriage return line feed
crlf	proc	near
	push	ax
	push	bx
	push	cx
	push	dx
	call	rdcurs		;read cursor
	mov	dl,0		;do CR
	inc	dh		; LF
	cmp	dh,25		;if end of
	jb	cr1		; screen
	mov	cx,0		;scroll
	mov	dx,184fh	; entire
	mov	bh,07h		; screen
	mov	ax,0601h	; up
	int	10h		; 1 line
	mov	dx,1800h	;CR
	mov	bh,0		;page 0
cr1:	call	setcur		;set cursor
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
crlf	endp

	page
;	tab
tab	proc	near
	push	ax
	push	bx
	push	dx
	mov	bh,0
	mov	ah,3		;read cursor
	int	10h
	add	dl,5		;mov cursor +5
	mov	ah,2
	int	10h		;set cursor
	pop	dx
	pop	bx
	pop	ax
	ret
tab	endp

;	get attribute of character at 
;	 dx = row:col and store in bl
getatt	proc	near
	push	ax
	call	setcur		;set cursor
	mov	bh,0		;page 0
	mov	ah,8		;read char/attr
	int	10h
	mov	bl,ah		;bl = attrib
	pop	ax
	ret
getatt	endp

;	change attribute of character at 
;	 current cursor position to bl
chgatt	proc	near
	push	ax
	push	bx
	push	cx
	mov	bh,0		;page 0
	mov	ah,8		;read char/attr
	int	10h
	mov	cx,1
	mov	ah,9
	int	10h		;write char/att
	pop	cx
	pop	bx
	pop	ax
	ret
chgatt	endp

	page
;	invert attribute of word at current
;	 cursor position
invatt	proc	near
	push	ax
	push	bx
	push	cx
	mov	bh,0		;page 0
ia1:	mov	ah,8		;read char/attr
	int	10h
	cmp	al,20h		;if blank
	je	ia4		; quit
	cmp	ah,07h		;if normal
	jne	ia2
	mov	bl,70h		;make inverse
	jmp	ia3		;else
ia2:	mov	bl,07h		;make normal
ia3:	mov	cx,1
	mov	ah,9
	int	10h		;write char/att
	call	inccur		;adv cursor
	jmp	ia1		;repeat
ia4:	pop	cx
	pop	bx
	pop	ax
	ret
invatt	endp

;	toggle attribute of character
;	at current cursor position
togatt	proc	near
	push	ax
	push	bx
	push	cx
	mov	bh,0		;page 0
	mov	ah,8		;read char/attr
	int	10h
	cmp	ah,07h		;if normal
	jne	ta1
	mov	bl,70h		;make inverse
	jmp	ta2		;else
ta1:	mov	bl,07h		;make normal
ta2:	mov	cx,1
	mov	ah,9
	int	10h		;write char/att
	pop	cx
	pop	bx
	pop	ax
	ret
togatt	endp

	page
;	invert line of text at
;	current cursor position
invline	proc	near
	push	ax
ivl1:	call	invatt		;invert word
	call	togatt		;invert blank
	call	inccur		;inc cursor
	mov	ah,8		;read chr/attr
	int	10h
	cmp	al,20h		;repeat until
	jne	ivl1		;blank
	pop	ax
	ret
invline	endp

;	blank line dh
blank	proc	near
	push	ax
	push	bx
	push	cx
	push	dx
	mov	dl,0		;col 0
	call	setcur		;set cursor
	mov	cx,80		;80 blanks
	mov	al,20h		;ascii blank
	mov	bl,07h		;normal video
	mov	ah,9
	int	10h		;print all 80
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
blank	endp

;	clear window
;	ch:cl = row:col of upper left corner
;	dh:dl = row:col of lower right corner
clrwin	proc	near
	push	ax
	push	bx
	mov	bh,7		;normal attr
	mov	ah,6		;scroll func
	mov	al,0		;blank window
	int	10h
	pop	bx
	pop	ax
	ret
clrwin	endp

	page
;	hide cursor
curoff	proc	near
	push	ax
	push	bx
	push	dx
	mov	bh,0		;page 0
	mov	dh,25		;row 25
	mov	dl,0		;col 0
	mov	ah,2		;set cursor
	int	10h		; off screen
	pop	dx
	pop	bx
	pop	ax
	ret
curoff	endp

;	print a char using teletype mode
chrprt	proc	near
	push	ax
	push	bx
	mov	bh,0	 	;page 0
	mov	ah,0eh		;write char in
	int	10h		; al on screen
	pop	bx
	pop	ax
	ret
chrprt	endp

;	hex to ascii conversion
hexasc	proc	near
	cmp	al,0ah		;if >= 0ah
	jb	ha1
	add	al,37h		;add 37h
	jmp	ha2
ha1:	add	al,30h		;else add 30h
ha2:	ret
hexasc	endp

	page
;	print a byte
pbyte	proc	near
	push	ax
	push	cx
	push	ax		;save byte
	mov	cl,4
	shr	al,cl		;hi nibble
	call	hexasc		;conv to ascii
	call	chrprt		;print char
	pop	ax		;get byte
	and	al,0fh		;lo nibble
	call	hexasc		;con to ascii
	call	chrprt		;print char
	mov	al,20h		;print blank
	call	chrprt
	pop	cx
	pop	ax
	ret
pbyte	endp		

;	delay 
;	input:	ax = no. of ticks to delay
;		18.2 ticks per second
delay	proc	near
	push	ax		;save regs
	push	cx		
	push	dx
	push	ax		;push #ticks
	mov	ah,0		;time of day
	int	1Ah		; interrupt
	push	cx		;push hi count
	push	dx		;push lo count
	mov	bp,sp		;bp -> lo count
dly1:	mov	ah,0
	int	1Ah		;get new count
	sub	dx,[bp]
	sbb	cx,2[bp]	;calc diff
	cmp	dx,4[bp]	;repeat until
	jb	dly1		;diff > #ticks
	add	sp,6		;fix stack
	pop	dx		;restore regs
	pop	cx
	pop	ax
	ret
delay	endp

	page
;	make a tone 
;	dx = pitch of tone
;	bx = length of tone
tone	proc	near
	push	ax		;save regs
	push	bx
	push	cx
	push	dx
	mov	al,0b6h
	out	43h,al		;B6 in ctrl reg
	mov	al,dl		;LSB pitch ->
	out	42h,al		; counter reg
	mov	al,dh		;MSB pitch ->
	out	42h,al		; counter reg
	in	al,61h		;PPI port B
	mov	ah,al		; -> AH
	or	al,03h		;speaker on
	out	61h,al		;set bits 0,1
	push	ax
	mov	ax,bx		;delay bx ticks
	call	delay	
	pop	ax
	mov	al,ah		;speaker off
	out	61h,al
	pop	dx		;restore regs
	pop	cx
	pop	bx
	pop	ax
	ret
tone	endp

;	beep a tone
beep	proc	near
	push	bx
	push	dx
	mov	dx,0300h	;set pitch
	mov	bx,4		;delay .22 s
	call	tone
	pop	dx
	pop	bx
	ret
beep	endp

	page
;	wait for key and get key value 
;	output:	al = ascii code of key
;		function & cursor keys have 
;		al = scan code OR 80H
getkey	proc	near
gk1:	mov	ah,0
	int	16h		;wait for key
	cmp	ah,0		;ignore ^break
	je	gk1		;and Alt-keypd
	cmp	al,0
	jne	gk2		;if ascii = 0
	mov	al,ah		;use scan code 
	or	al,80h		; OR 80h
gk2:	ret
getkey	endp

;	process a key
;	input:	al = ascii code of key
;		di -> jump table
;		dx -> default subroutine
dokey	proc	near
dk1:	cmp	al,cs:[di]	;chk next code
	jne	dk2		;if a match
	call 	word ptr cs:1[di] ;call sub
	ret			;and quit
dk2:	cmp	byte ptr cs:[di],0 ;if not
	je	dk3		;end of table
	add	di,3		;chk next entry
	jmp	dk1		; in table
dk3:	call	dx  		;else call
	ret			;default sub
dokey	endp

	page
;	buffered keyboard input
;	at current cursor position
;	input asciiz string is at kbuf
;	# of character entered at span
;	output: none
query	proc	near
	mov	sisave,si
	mov	si,offset kbuf	;si->kbuf
qy1:	call	getkey		;get key
	mov	di,offset jmptbq
	mov	dx,offset tobuff ;default
	call	dokey		;process key
	jmp	qy1
query	endp


;	query jump table
jmptbq	db	_bksp		;backspace
	dw	backsp
	db	_enter		;enter
	dw	enterq
	db	_esc		;esc
	dw	quit
	db	0

;	display & store char in kbuf
tobuff	proc	near
	cmp	si,offset bufend
	jb	tb1		;if end.of.buf
	call	beep		; beep &
	ret			; quit
tb1:	mov	[si],al		;store char
	inc	si		;inc ptr
	call	chrout1		;display char
	ret
tobuff	endp

	page
;	backspace
backsp	proc	near
	cmp	si,offset kbuf
	ja	bk1		;if 1st char
	call	beep		; beep & ret
	ret
bk1:	dec si			;back up & put
	mov	byte ptr [si],20h ;20h in kbuf
	call	deccur		;back up & put
	mov	al,20h		;blank on
	call	chrout1		;screen
	call	deccur
	ret
backsp	endp

;	enter from query
;	exits from query
enterq	proc	near
	mov	byte ptr [si],0	;make asciiz
	sub	si,offset kbuf	;store #char
	mov	span,si		;in span
	mov	si,sisave	;restore si
	pop	ax		;>enterq
	pop	ax		;>dokey
	ret			;>query
enterq	endp

	page
;	resize memory
resize	proc	near
	mov	ax,es		;ax=psp seg
	mov	bx,ss		;bx=stack seg
	sub	bx,ax		;reserve psp-ss
	add	bx,10		; + stack size
	mov	ah,4Ah
	int	21h		;resize mem
	ret
resize	endp

;	allocate save screen buffer
svinit	proc	near
	mov	svseg,0		;svseg = 0
	mov	bx,1000		;request 16000
	mov	ah,48h		; bytes
	int	21h		
	jc	sv1		;if no error
	mov	svseg,ax	;svseg = seg
sv1:	ret
svinit	endp

;	release save screen buffer
relssb	proc	near
	cmp	svseg,0		;if allocated
	je	rel1
	mov	ax,svseg	;deallocate
	mov	es,ax		;es = svseg
	mov	ah,49h
	int	21h		;release mem
rel1:	ret
relssb	endp

	page
;	save screen
savescr	proc	near
	push	ax		;save regs
	push	cx
	push	si
	push	di
	push	ds
	push	es
	cmp	svseg,0		;if buff exists
	je	svsc3
	std			;move 12000 
	mov	ax,svseg	; bytes up 
	mov	ds,ax		; 4000 bytes
	mov	es,ax		; to make hole
	mov	cx,6000		; in buffer
	mov	si,11998
	mov	di,15998
	rep movsw
	mov	ah,15
	int 	10h		;get video state
	cmp	al,7
	je	svsc1		;set ax =
	mov	ax,0b800h	; video ram
	jmp	svsc2		; segment
svsc1:	mov	ax,0b000h
svsc2:	mov	ds,ax		; to svseg
	mov	si,0		; buffer
	mov	di,0
	mov	cx,2000
	cld
	rep movsw
svsc3:	pop	es		;restore regs
	pop	ds
	pop	di
	pop	si
	pop	cx
	pop	ax
	ret
savescr	endp

	page
;	restore screen
restscr	proc	near
	push	ax		;save regs
	push	cx
	push	si
	push	di
	push	ds
	push	es
	cmp	svseg,0		;if buff exists
	je 	rsts3
	mov	ah,15
	int 	10h		;get video state
	cmp	al,7
	je	rsts1		;set ax =
	mov	ax,0b800h	; video ram
	jmp	rsts2		; segment
rsts1:	mov	ax,0b000h	;move 1st 4000
rsts2:	mov	es,ax		; bytes from
	mov	ax,svseg	; svseg buffer
	mov	ds,ax		; to tv ram
	mov	si,0
	mov	di,0
	mov	cx,2000
	cld
	rep movsw
	mov	ax,data
	mov	ds,ax		;ds = data
	mov	ax,svseg	;move last    
	mov	es,ax		; 12000 bytes 
	mov	ds,ax		; in buffer
	mov	si,4000		; down 4000 
	mov	di,0		; bytes
	mov	cx,6000
	rep movsw
rsts3:	pop	es		;restore regs
	pop	ds
	pop	di
	pop	si
	pop	cx
	pop	ax
	ret
restscr	endp

;	quit to dos
quit	proc	near
	mov	ax,4C00h
	int	21h
quit	endp

code	ends
	end


 



			
